%set up the model (global variables)

global  time dt
global  line_length depth
global  sources receivers spacing
global  velocity1 layer 
global  tref wref

load wavelet.mat
%load model1.mat

dt = 2;          % time sampling interval
time = 0:dt:800;  % time sampling
amplitude = 50;

sources = [250 500 750];     % positions of three sources
receivers = 0:25:1000;    % positions of 41 receivers
depth = 500;
velocity1 = 2;

line_length = receivers(end);                 % total length of seismic line
spacing = line_length/(length(receivers)-1);  % receiver spacing

% draw and pick a reflecting layer
 
layer1 = picklayer(line_length,depth);

layer2 = picklayer(line_length,depth,layer1);

layer3 = picklayer(line_length,depth,layer1,layer2);

% print out the picked points
layer1

% model reflection seismograms

section1 = reflection(sources(1),receivers,layer1,velocity1);
section2 = reflection(sources(2),receivers,layer2,velocity1);
section3 = reflection(sources(3),receivers,layer3,velocity1);

plot_section(receivers,section1,'Distance(m)','b-')
plot_section(receivers,section2,'Distance(m)','r-')
plot_section(receivers,section3,'Distance(m)','g-')
plot(sources,[0 0 0],'ko')

% save the model and resulting section

save model1.mat layer*   section* 

