% Plots traces and positions of sources
%
% Input parameters:
%   recs - receiver coordinates for the section 
%   section - trace section as returned by 'reflection()' 
%           (should be calculated with the same receivers)
%   X_axis_label - label of the horizontal axis
%   linestyle - line style used for this section

function plot_section(recs,section,X_axis_label,linestyle)

global  time dt
global  sources receivers spacing

  hold on
  
%      # plot traces one by one, vertically, downward
 
  set(gca,'YDir','reverse');  % reverse the vertical axis
  xlabel(X_axis_label);
  ylabel('Time (ms)');

  for i=1:size(section,2)
    
    plot(section(:,i)+recs(i),time,linestyle);
      
  end  
  
end
